/**
  * This file contains definition for IOCTL call.
  */
#ifndef	_WLAN_WEXT_H_
#define	_WLAN_WEXT_H_

#define COSTS_LIST_SIZE			4

/* iwpriv places the subcmd number in the first u32; data buffer follows that */
#define SUBCMD_OFFSET			sizeof(u32)
#define SUBCMD_DATA(x)			*((int *)(x->u.name + SUBCMD_OFFSET))

/** Private ioctls and ioctls subcommands */
#define LIBERTAS_SETNONE_GETNONE	        (SIOCIWFIRSTPRIV + 8)
#define LIBERTAS_SUBCMD_BT_RESET		13
#define LIBERTAS_SUBCMD_FWT_RESET		14

#define LIBERTAS_SETNONE_GETONEINT		(SIOCIWFIRSTPRIV + 15)
#define LIBERTAS_SUBCMD_GET_REGION		1
#define LIBERTAS_SUBCMD_FWT_CLEANUP		15
#define LIBERTAS_SUBCMD_FWT_TIME		16
#define LIBERTAS_SUBCMD_MESH_GET_TTL		17
#define LIBERTAS_SUBCMD_BT_GET_INVERT		18
#define LIBERTAS_SUBCMD_MESH_GET_BCAST_RATE	19
#define LIBERTAS_SUBCMD_MESH_GET_RREQ_DELAY	20
#define LIBERTAS_SUBCMD_MESH_GET_ROUTE_EXP	21

#define LIBERTAS_SETONEINT_GETNONE		(SIOCIWFIRSTPRIV + 24)
#define LIBERTAS_SUBCMD_SET_REGION		8
#define LIBERTAS_SUBCMD_MESH_SET_TTL		18
#define LIBERTAS_SUBCMD_BT_SET_INVERT		19
#define LIBERTAS_SUBCMD_MESH_SET_BCAST_RATE	20
#define LIBERTAS_SUBCMD_MESH_SET_RREQ_DELAY	21
#define LIBERTAS_SUBCMD_MESH_SET_ROUTE_EXP	22

#define LIBERTAS_SET128CHAR_GET128CHAR		(SIOCIWFIRSTPRIV + 25)
#define LIBERTAS_SUBCMD_BT_ADD			18
#define LIBERTAS_SUBCMD_BT_DEL   		19
#define LIBERTAS_SUBCMD_BT_LIST			20
#define LIBERTAS_SUBCMD_FWT_ADD			21
#define LIBERTAS_SUBCMD_FWT_DEL   		22
#define LIBERTAS_SUBCMD_FWT_LOOKUP		23
#define LIBERTAS_SUBCMD_FWT_LIST_NEIGHBOR	24
#define LIBERTAS_SUBCMD_FWT_LIST		25
#define LIBERTAS_SUBCMD_FWT_LIST_ROUTE		26
#define LIBERTAS_SUBCMD_MESH_SET_LINK_COSTS	27
#define LIBERTAS_SUBCMD_MESH_GET_LINK_COSTS	28

#define LIBERTAS_SET_GET_SIXTEEN_INT		(SIOCIWFIRSTPRIV + 29)
#define LIBERTAS_LED_GPIO_CTRL			5
#define LIBERTAS_BCN_CTRL               	6
#define LIBERTAS_LED_BEHAVIOR_CTRL		7

/** wlan_ioctl_regrdwr */
struct wlan_ioctl_regrdwr {
	/** Which register to access */
	u16 whichreg;
	/** Read or Write */
	u16 action;
	u32 offset;
	u16 NOB;
	u32 value;
};

#define WLAN_MONITOR_OFF			0

extern struct iw_handler_def libertas_handler_def;
extern struct iw_handler_def mesh_handler_def;
int libertas_do_ioctl(struct net_device *dev, struct ifreq *req, int i);

#endif				/* _WLAN_WEXT_H_ */
